library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use work.ADV212_Command.all;

entity testbench is

end testbench;

architecture behaivor of testbench is

component ADV212_ansteuern

port( clk:						in		std_logic;									-- Clock
			rstn:					in		std_logic:= '0';
			ADDR:					out   std_logic_vector(3 downto 0);
			HDATA:				inout	std_logic_vector(15 downto 0);
			IRQ:					in		std_logic;
			VALID:				in		std_logic;
			HOLD:					inout 	std_logic:= '0';
			ACK:					in		std_logic;
			RD,WE,CS:			out	std_logic:= '0'
			
	  );
end component;
	  
signal tb_clk, tb_rstn,tb_IRQ,tb_VALID,tb_HOLD,tb_RD,tb_WE,tb_CS: std_logic;	 
signal tb_ACK: std_logic;
signal tb_ADDR:	std_logic_vector(3 downto 0);
signal tb_HDATA:	std_logic_vector(15 downto 0); 

begin

uut: ADV212_ansteuern


port map(clk => tb_clk,
			rstn => tb_rstn,
			ADDR => tb_ADDR,
			HDATA => tb_HDATA,
			IRQ => tb_IRQ,
			VALID => tb_VALID,
			HOLD => tb_HOLD,
			ACK => tb_ACK,
			RD => tb_RD,
			WE => tb_WE,
			CS => tb_CS

			);

clk_sig: process

begin 

tb_clk <= '1';
wait for 3 ns;
tb_clk <='0';
wait for 3 ns;
end process; 

--tb_CS <= '1';
--tb_RD <= '0';
--tb_WE <='1';
tb_ACK <= '0';
tb_rstn <= '1', '0' after 20 ns;
tb_IRQ  <= '0'; --, '0' after 121 ns; 
tb_Valid <= '0', '1' after 355 ns, '0' after 500 ns, '1' after 700 ns, '0' after 800 ns;

tb_HDATA <= "ZZZZZZZZZZZZZZZZ","0000010000000000" after 175 ns,"ZZZZZZZZZZZZZZZZ" after 180 ns,"0000010000000000" after 250 ns, "ZZZZZZZZZZZZZZZZ" after 260 ns, "1111111110000010" after 350 ns, "ZZZZZZZZZZZZZZZZ" after 355 ns; 
end;

